﻿using System.Configuration;
using System.Linq;
using Oracle.DataAccess.Client;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;

namespace EFOracle
{
    class Program
    {
        static void Main(string[] args)
        {

            using (var ctx = new Context())
            {
                var data = ctx.Countries.ToList();
                ctx.Countries.Add(new Country() { CountryID = "CL", CountryName = "Chile", RegionID = 2 });
                ctx.SaveChanges();
            }
        }
    }

    public class Country
    {
        public string CountryID { get; set; }
        public string CountryName { get; set; }
        public decimal RegionID { get; set; }
    }

    public class Context : DbContext
    {
        public Context()
            : base(new OracleConnection(ConfigurationManager.ConnectionStrings["OracleHR"].ConnectionString), true)
        {

        }
        public DbSet<Country> Countries { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            base.OnModelCreating(modelBuilder);
            modelBuilder.Conventions.Remove<IncludeMetadataConvention>();
            modelBuilder.Entity<Country>().Property(p => p.CountryID).HasColumnName("COUNTRY_ID");
            modelBuilder.Entity<Country>().HasKey(p => p.CountryID);
            modelBuilder.Entity<Country>().Property(p => p.CountryName).HasColumnName("COUNTRY_NAME");
            modelBuilder.Entity<Country>().Property(p => p.RegionID).HasColumnName("REGION_ID");
            modelBuilder.Entity<Country>().ToTable("COUNTRIES", "HR");
        }
    }

}
